// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/12AI64/12AI64_Linux_1.x.x.x_DN/samples/fsamp/perform.c $
// $Rev: 50190 $
// $Date: 2022-02-09 08:33:11 -0600 (Wed, 09 Feb 2022) $

// 12AI64: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	FILE_NAME				"fsamp.txt"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	s32		enable_a;
	s32		enable_b;
	int		errs		= 0;
	FILE*	file		= NULL;
	int		fsamp;
	s32		max			= 0;
	s32		min			= 0;
	s32		nrate_a;
	s32		nrate_b;
	double	rate;
	s32		src;
	s32		src_b;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (args->range == 0)
	{
		min		= args->fsamp;
		max		= args->fsamp;
	}
	else
	{
		errs	+= ai64_query(args->fd, -1, 0, AI64_QUERY_FSAMP_MAX, &max);
		errs	+= ai64_query(args->fd, -1, 0, AI64_QUERY_FSAMP_MIN, &min);
	}

	if (args->save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 12AI64 Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  ==========\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		errs	+= ai64_fsamp_ai_compute(args->fd, -1, 1, fsamp, &src, &src_b, &nrate_a, &nrate_b, &enable_a, &enable_b, &rate);

		if (file)
			fprintf(file, "%10ld  %10.3f\n", (long) fsamp, (float) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


