// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/12AI64/12AI64_Linux_1.x.x.x_DN/utils/ioctl.c $
// $Rev: 51850 $
// $Date: 2022-10-19 10:05:20 -0500 (Wed, 19 Oct 2022) $

// 12AI64: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64_ioctl_util
*
*	Purpose:
*
*		Implement a visual wrapper around the device IOCTL call.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		request	The IOCTL service to request.
*
*		arg		The argument for the IOCTL service.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int ai64_ioctl_util(int fd, int index, int verbose, int request, void *arg)
{
	int	errs	= 0;
	int	ret;

	if (verbose)
		gsc_label_index("IOCTL", index);

	ret		= ai64_ioctl(fd, request, arg);
	errs	+= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s  (#%d)\n",
				errs ? "FAIL <---" : "PASS",
				(int) OS_IOCTL_INDEX_DECODE(request));
	}

	return(errs);
}


