// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/12AI64/12AI64_Linux_1.x.x.x_DN/utils/read.c $
// $Rev: 49658 $
// $Date: 2021-08-23 16:33:40 -0500 (Mon, 23 Aug 2021) $

// 12AI64: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64_read_util
*
*	Purpose:
*
*		Implement a visual wrapper around the device read call.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		dst		The data read is placed here.
*
*		bytes	The voume of data to read.
*
*	Returned:
*
*		>= 0	The volume of data read.
*		< 0		The negative of the number of errors seen.
*
******************************************************************************/

int ai64_read_util(int fd, int index, int verbose, void* dst, size_t bytes)
{
	int	ret;

	if (verbose)
		gsc_label_index("Reading", index);

	ret	= ai64_read(fd, dst, bytes);

	if (verbose == 0)
	{
	}
	else if (ret >= 0)
	{
		printf("PASS  (%d bytes)\n", ret);
	}
	else
	{
		printf("FAIL <---\n");
	}

	return(ret);
}


