// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/12AI64/12AI64_Linux_1.x.x.x_DN/utils/util_chan_single.c $
// $Rev: 42816 $
// $Date: 2018-05-17 13:15:42 -0500 (Thu, 17 May 2018) $

// 12AI64: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64_chan_single
*
*	Purpose:
*
*		Provide a visual wrapper for the AI64_IOCTL_CHAN_SINGLE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai64_chan_single(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs	= 0;
	int	ret;

	if (verbose)
		gsc_label_index("Single Channel Scan", index);

	ret		= ai64_ioctl(fd, AI64_IOCTL_CHAN_SINGLE, &set);
	errs	+= ret ? 1 : 0;

	if (verbose)
		printf("%s  (channel %ld)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


